import { Component } from '@angular/core';
import { CountryMandatoryFieldService } from '../country-mandatory-field.service';

@Component({
  selector: 'app-country-mandatory-field',
  templateUrl: './country-mandatory-field.component.html',
  styleUrls: ['./country-mandatory-field.component.css'],
})
export class CountryMandatoryFieldComponent {
  countryMandatoryField: any;
  countryType: any;
  countryMandatory: any;
  countryModeOfPayment: any;
  gridList: any;
  countryList: any;
  CountryID: any;
  PermissionID: any;
  ModeOfPayment_ID: any;
  constructor(private countryMandatoryFieldSVC: CountryMandatoryFieldService) {}

  ngOnInit(): void {
    this.getTypesOfMandatory();
  }

  getTypesOfMandatory() {
    this.countryMandatoryFieldSVC.getTypesOfMandatory().subscribe((res) => {
      this.countryMandatoryField = res;
    });
  }

  getCountryType() {
    this.countryMandatoryFieldSVC.getCountryType().subscribe((res) => {
      this.countryType = res;
    });
  }

  getCountrylist(CountryType) {
    this.countryMandatoryFieldSVC
      .getCountryList(CountryType)
      .subscribe((res) => {
        this.countryList = res;
      });
  }

  getModeOfPayment(CountryID: any) {
    this.countryMandatoryFieldSVC
      .getModeOfPayment(CountryID)
      .subscribe((res) => {
        this.countryModeOfPayment = res;
      });
  }
  getGrid() {
    this.countryMandatoryFieldSVC
      .getGrid(
        this.countryMandatory,
        this.PermissionID,
        this.CountryID,
        this.ModeOfPayment_ID
      )
      .subscribe((res) => {
        this.gridList = res;
      });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  onSelectTypesOfMandatory($event: any) {
    this.countryMandatory = $event.target.value;
    this.getCountryType();
  }

  onSelectCountryType(CountryType: any) {
    this.PermissionID = CountryType.target.value;
    this.getCountrylist(CountryType.target.value);
  }

  onSelectCountryList(CountryID: any) {
    this.CountryID = CountryID.target.value;
    this.getModeOfPayment(CountryID.target.value);
  }

  onSelectModeOfPayment(ModeOfPaymentID: any) {
    this.ModeOfPayment_ID = ModeOfPaymentID.target.value;
  }
}
