import { Component } from '@angular/core';
import { DownloadTransactionsFileService } from '../download-transactions-file.service';

@Component({
  selector: 'app-download-transactions-file',
  templateUrl: './download-transactions-file.component.html',
  styleUrls: ['./download-transactions-file.component.css'],
})
export class DownloadTransactionsFileComponent {
  constructor(private downTrnFileSvc: DownloadTransactionsFileService) {}

  searchByType: any = '0';
  searchText: any;
  UserName: any;
  Data: any;

  ngOnInit() {
    this.getTransactionDownloadFile();
  }

  getTransactionDownloadFile() {
    this.downTrnFileSvc.getTransactionDownloadFileList(0, 1).subscribe({
      next: (res: any) => {
        // this.Data = res;
        this.Data = this.removeAnchorTagFromArray(res);
      },
    });
  }
  removeAnchorTagFromArray(dataArray: any[]): any[] {
    return dataArray.map((item) => {
      if (item && item.PM_FILENM) {
        // Use a regular expression to remove the entire anchor tag
        item.PM_FILENM = item.PM_FILENM.replace(/<a\s*.*?>|<\/a>/gi, '');
      }
      return item;
    });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  SearchType(event) {
    this.searchByType = Number(event.target.value);
  }

  showAuditData() {
    if (this.searchText && this.searchByType) {
      this.downTrnFileSvc
        .getTransactionDownloadFileList(this.searchText, this.searchByType)
        .subscribe({
          next: (res: any) => {
            this.Data = res;
          },
          error: (err) => {
            this.Data = [];
          },
          complete: () => {},
        });
    } else {
      this.getTransactionDownloadFile();
    }
  }
}
