import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class EditBeneficiaryRegistrationService {
  constructor(private http: HttpClient) {}

  getCustomer(CustomerNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/edit-beneficiary-registration/search-customer?CustomerNumber=${CustomerNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewCustomer(ID: any, ModuleID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/edit-beneficiary-registration/view?ID=${ID}&ModuleID=${ModuleID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
