import { Component } from '@angular/core';
import { EditTransactionService } from '../services/edit-transaction.service';
import { ManageCountryPermissionService } from '../services/manage-country-permission.service';
import { Router } from '@angular/router';

@Component({
  selector: 'app-edit-transaction',
  templateUrl: './edit-transaction.component.html',
  styleUrls: ['./edit-transaction.component.css'],
})
export class EditTransactionComponent {
  baseCountries: any = -1;
  searchByType: any = 1;
  status: any = [
    {
      Id: -1,
      Value: 'ALL',
    },
  ];
  TransferTypeList: any = [];
  payinCountryList: any = -1;
  viewLast: any = -1;
  statusId: any = -1;
  data: any;
  startDate: any;
  endDate: any;
  transactionNo: any;
  customerNameFirst: any;
  customerNameLast: any;
  beneficiaryNameFirst: any;
  beneficiaryNameLast: any;

  constructor(
    private EditTrSvc: EditTransactionService,
    private mangcountpermissionsvc: ManageCountryPermissionService,
    private router: Router
  ) {}
  ngOnInit() {
    this.getSerchStatusList();
    this.getReceivingCountryPermission();
    this.getpayinCountryList();
    this.getTransferTypeList();
  }

  getSerchStatusList() {
    this.EditTrSvc.getSerchStatusList().subscribe({
      next: (res: any) => {
        this.status = this.status.concat(
          res.map((t) => {
            return {
              ID: t.TrStatusID,
              Value: t.Tr_Status_Name,
            };
          })
        );
      },
    });
  }

  getReceivingCountryPermission() {
    this.mangcountpermissionsvc.getReceivingCountryPermission().subscribe({
      next: (res: any) => {
        this.baseCountries = res;
      },
    });
  }

  getpayinCountryList() {
    this.EditTrSvc.getPayinCountryList().subscribe({
      next: (res: any) => {
        this.payinCountryList = res;
      },
    });
  }

  getTransferTypeList() {
    this.EditTrSvc.getTransferTypeList().subscribe({
      next: (res: any) => {
        this.TransferTypeList = res;
      },
    });
  }

  getFillGrid() {
    let payload: any = {};

    if (this.searchByType === 2) {
      payload = {
        SearchByType: this.searchByType,
        TopRecord: this.viewLast,
        Agent_ID: 0,
        PayOutCountry: -1,
        PayOutCurrency: -1,
        SubType: -1,
        // SRTRNo: '',
        TrStatusID: this.statusId,
        TrStatusList: this.status,
        TrTypeID: -1,
        PayInCountry: -1,
        PayInCurrency: -1,
        UserID: '-1',
        AgentBranchId: -1,
      };
    }
    if (this.searchByType === 1) {
      payload = {
        SearchByType: this.searchByType,
        TopRecord: this.viewLast,
        Agent_ID: 0,
        PayOutCountry: -1,
        PayOutCurrency: -1,
        SubType: -1,
        SRTRNo: this.transactionNo,
        TrStatusID: this.statusId,
        TrStatusList: this.status,
        TrTypeID: -1,
        PayInCountry: -1,
        PayInCurrency: -1,
        UserID: '-1',
        AgentBranchId: -1,
      };
    }
    if (this.searchByType === 3) {
      payload = {
        SearchByType: this.searchByType,
        TopRecord: this.viewLast,
        Agent_ID: 0,
        PayOutCountry: -1,
        PayOutCurrency: -1,
        SubType: -1,
        SRTRNo: this.transactionNo,
        TrStatusID: this.statusId,
        TrStatusList: this.status,
        TrTypeID: -1,
        StartDate: this.startDate,
        EndDate: this.endDate,
        PayInCountry: -1,
        PayInCurrency: -1,
        UserID: '-1',
        AgentBranchId: -1,
        Beneficiary_Name_F: this.beneficiaryNameFirst
          ? this.beneficiaryNameFirst
          : '',
        Beneficiary_Name_L: this.beneficiaryNameLast
          ? this.beneficiaryNameLast
          : '',
        Customer_Name_F: this.customerNameFirst ? this.customerNameFirst : '',
        Customer_Name_L: this.customerNameLast ? this.customerNameLast : '',
      };
      console.log('this.startDate: ', this.startDate);
    }
    this.EditTrSvc.getFillGrid(payload).subscribe({
      next: (res: any) => {
        this.data = res;
      },
    });
  }

  ViewLast($event) {
    this.viewLast = $event.target.value;
  }

  SearchType(event) {
    this.searchByType = Number(event.target.value);
   }

  onChangeStatus(event: any) {
    this.statusId = !isNaN(Number(event.target.value))
      ? Number(event.target.value)
      : -1;
  }

  editTransaction(transaction: any) {
    if (transaction?.App_ID && transaction?.Ex_Branch_ID) {
      this.router.navigate([
        '/panel/edit-transaction-detail',
        transaction?.Ex_Branch_ID,
        transaction?.App_ID,
      ]);
    }
  }

  approved() {
    const updatedTransactions = this.data
      .filter((con) => con.isChecked)
      .map((con) => ({
        IsChkCheked: true,
        hid: con?.hid,
      }));
    if (updatedTransactions?.length) {
      const payload = {
        UserID: '1',
        GroupID: 0,
        HidValue: updatedTransactions,
      };
      this.EditTrSvc.statusApproved(payload).subscribe({
        next: (res: any) => {},
        error: (err) => {
          alert(err?.error?.message || 'Something went wrong');
        },
        complete: () => {},
      });
    }
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
