import { Component } from '@angular/core';
import { GlobalTransactionLimitService } from '../services/global-transaction-limit.service';

@Component({
  selector: 'app-global-transaction-limit',
  templateUrl: './global-transaction-limit.component.html',
  styleUrls: ['./global-transaction-limit.component.css'],
})
export class GlobalTransactionLimitComponent {
  globalTransactionLimitList: any = [];
  transactionLimit: any = '';
  transactionLimitBank: any = '';

  constructor(private globalTransactionSvc: GlobalTransactionLimitService) {}

  ngOnInit(): void {
    this.getGlobalTransactionList();
  }

  getGlobalTransactionList() {
    this.globalTransactionSvc.getGlobalTransactionList().subscribe({
      next: (res: any) => {
        this.globalTransactionLimitList =
          res?.GlobalPerTranMonthlyThresholdLimits;
        this.transactionLimit = res?.TransactionLimitInUSD;
        this.transactionLimitBank = res?.TransactionLimitInUSD_Bank;
      },
      error: (err) => {
        this.globalTransactionLimitList = [];
      },
      complete: () => {},
    });
  }

  updateGlobalLimit() {
    if (!this.transactionLimit && !this.transactionLimitBank) {
      alert('Please Fill Cash & Bank Fields.');
      return;
    }
    this.globalTransactionSvc
      .updateGlobalLimit('', this.transactionLimit, this.transactionLimitBank)
      .subscribe({
        next: (res: any) => {
          this.getGlobalTransactionList();
          alert('Global Transaction Limit Updated successfully.');
        },
        error: (err) => {},
        complete: () => {},
      });
  }

  updateSegment() {
    const payload = {
      SegPlatinumPerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_Platinum_PerTran_Limit,
      SegPlatinumMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_Platinum_Monthly_Limit,
      chkPlatinum_IsActive:
        this.globalTransactionLimitList[0].GMPSL_Platinum_IsActive,
      SegGoldPerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_Gold_PerTran_Limit,
      SegGoldMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_Gold_Monthly_Limit,
      chkGold_IsActive: this.globalTransactionLimitList[0].GMPSL_Gold_IsActive,
      SegSilverPerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_Silver_PerTran_Limit,
      SegSilverMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_Silver_Monthly_Limit,
      chkSilver_IsActive:
        this.globalTransactionLimitList[0].GMPSL_Silver_IsActive,
      SegStaffPerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_Staff_PerTran_Limit,
      SegStaffMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_Staff_Monthly_Limit,
      chkStaff_IsActive:
        this.globalTransactionLimitList[0].GMPSL_Staff_IsActive,
      SegEasyPayPerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_EasyPay_PerTran_Limit,
      SegEasyPayMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_EasyPay_Monthly_Limit,
      chkEasyPay_IsActive:
        this.globalTransactionLimitList[0].GMPSL_EasyPay_IsActive,
      SegVMobilePerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_VMobile_PerTran_Limit,
      SegVMobileMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_VMobile_Monthly_Limit,
      chkVMobile_IsActive:
        this.globalTransactionLimitList[0].GMPSL_VMobile_IsActive,
      SegPrivatePerTranLimit:
        this.globalTransactionLimitList[0].GMPSL_Private_PerTran_Limit,
      SegPrivateMonthlyLimit:
        this.globalTransactionLimitList[0].GMPSL_Private_Monthly_Limit,
      chkPrivate_IsActive:
        this.globalTransactionLimitList[0].GMPSL_Private_IsActive,
      UserID: 0,
    };
    this.globalTransactionSvc.updateSegmentLimit(payload).subscribe({
      next: (res: any) => {
        this.getGlobalTransactionList();
        alert(
          'Per Transaction and Monthy Threshold Transaction Limit Updated successfully.'
        );
      },
      error: (err) => {},
      complete: () => {},
    });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
