import { Component, TemplateRef, ViewChild } from '@angular/core';
import { ManageCifWiseCommissionService } from '../manage-cif-wise-commission.service';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { AgentWiseCommissionService } from '../services/agent-wise-commission.service';
import { FormControl, FormGroup, Validators } from '@angular/forms';

@Component({
  selector: 'app-manage-cif-wise-comission',
  templateUrl: './manage-cif-wise-comission.component.html',
  styleUrls: ['./manage-cif-wise-comission.component.css'],
})
export class ManageCifWiseComissionComponent {
  @ViewChild('ManageCifWiseComissionModel') ManageCifWiseComissionModel;
  sendCountry: any;
  countryID: any;
  CurType: any = [];
  CurrencyType: any;
  sendCurrencyType: any = [];
  sendAgent: any;
  type: any;
  receiveCurrencyType: any = [];
  receiveCountryList: any;
  receiveAgentList: any;
  ReceiveAgentInsertList: any;
  receiveCountryID: any;
  modeOfPayment: any;
  RangeCurrency: any;
  ReceiveAgentID: any;
  subAgentList: any;
  modeOfPaymentID: any;
  agentID: any;
  allRecord: any;
  subAgentID: any;
  sendCountryInsertList: any;
  insertReceiveCountryList: any;
  bsModalRef: BsModalRef;
  PayInCountryId: any;
  selectReceiveCurrencyID: any;
  sendAgentInsertList: any;
  ReceiveAgentInsert: any;
  sendCurrencyInsertList: any;
  TotalCommissionType: any;
  ModeOfPaymentInsert: any;
  Agent_ID: any;
  ReceiveSubAgentInsertList: any;
  cifNumber: any;
  insertReceiveCurrencyList: any;
  ManageCifWiseCommissionForm = new FormGroup({
    PayInCountryId: new FormControl('None', Validators.required),
    AgentID: new FormControl('None', Validators.required),
    PayInCurrencyID: new FormControl('None', Validators.required),
    PayOutCountryId: new FormControl('None', Validators.required),
    PayOutCurrencyID: new FormControl('None', Validators.required),
    ModeOfPayment_ID: new FormControl('None', Validators.required),
    CIFNumber: new FormControl('None', Validators.required),
    StartRange: new FormControl('', Validators.required),
    EndRange: new FormControl('', Validators.required),
    BaseToBaseCommissionAmount: new FormControl('', Validators.required),
    PayCommissionType: new FormControl('None', Validators.required),
    PayInCommissionType: new FormControl('None', Validators.required),
    PayInCurrencyType: new FormControl('None', Validators.required),
    PayInCommissionAmount: new FormControl('', Validators.required),
    PayOutCommissionType: new FormControl('None', Validators.required),
    PayOutCurrencyType: new FormControl('None', Validators.required),
    PayOutCommissionAmount: new FormControl('', Validators.required),
    IschkMinMax: new FormControl('', Validators.required),
    ReceiverFixAmount: new FormControl('', Validators.required),
    ReceiverMinAmount: new FormControl('', Validators.required),
    ReceiverMaxAmount: new FormControl('', Validators.required),
    RecAgentID: new FormControl('None', Validators.required),
    SubAgentID: new FormControl(null, Validators.required),
    IsSubAgent: new FormControl('', Validators.required),
    RangeCurrencyType: new FormControl('None', Validators.required),
    EnteredBy: new FormControl('', Validators.required),
    ID: new FormControl('', Validators.required),
  });
  constructor(
    private ManageCifWiseComissionSvc: ManageCifWiseCommissionService,
    private modalService: BsModalService,
    private agentWiseCommissionSvc: AgentWiseCommissionService
  ) {}

  ngOnInit(): void {
    this.getSendCountry();
    this.getModeOfPayment();
  }

  openModal(template: TemplateRef<any>) {
    this.bsModalRef = this.modalService.show(template, {
      class: 'modal-lg',
    });
  }
  openManageCifWiseComissionModel(type: any) {
    this.type = type;
    if (type == 'add') {
      this.ManageCifWiseCommissionForm.reset({
        PayInCountryId: 'None',
        AgentID: 'None',
        ModeOfPayment_ID: 'None',
        CIFNumber: 'None',
        PayInCurrencyID: 'None',
        PayOutCountryId: 'None',
        PayOutCurrencyID: 'None',
        RecAgentID: 'None',
        SubAgentID: null,
        RangeCurrencyType: 'None',
        StartRange: '',
        EndRange: '',
        BaseToBaseCommissionAmount: '',
        PayCommissionType: 'None',
        PayInCommissionType: 'None',
        PayInCurrencyType: 'None',
        PayInCommissionAmount: '',
        PayOutCommissionType: 'None',
        PayOutCurrencyType: 'None',
        PayOutCommissionAmount: '',
      });
    }
    this.openModal(this.ManageCifWiseComissionModel);
    this.getInsertReceiveCountry();
    this.getSendCountryInsert();
    this.getCifNumber();
    this.getTotalCommissionType();
  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  getSendCountry() {
    this.ManageCifWiseComissionSvc.getSendCountry().subscribe((res) => {
      this.sendCountry = res[0].Country;
    });
  }

  onSelectCountry($event) {
    this.countryID = $event.target.value;
    this.getSendAgent(this.countryID);
    this.getReceiveCountryList(this.countryID);
    this.getReceiveAgentList(this.countryID);
  }

  getSendAgent(CountryID: any) {
    this.ManageCifWiseComissionSvc.getSendAgent(CountryID).subscribe((res) => {
      this.sendAgent = res;
    });
  }

  onSelectAgent($event) {
    this.agentID = $event.target.value;
  }
  getReceiveCountryList(CountryID: any) {
    this.ManageCifWiseComissionSvc.getReceiveCountryList(CountryID).subscribe(
      (res) => {
        this.receiveCountryList = res;
      }
    );
  }

  onSelectReceiveCountry($event) {
    this.receiveCountryID = $event.target.value;
    this.getReceiveAgentList(this.receiveCountryID);
    this.getReceiveCurrencyInsert(this.receiveCountryID);
  }

  getReceiveAgentList(CountryID: any) {
    this.ManageCifWiseComissionSvc.getReceiveAgentList(CountryID).subscribe(
      (res) => {
        this.receiveAgentList = res;
      }
    );
  }
  onSelectReceiveAgent($event) {
    this.ReceiveAgentID = $event.target.value;
    this.getSubAgentList(this.ReceiveAgentID);
  }

  getModeOfPayment() {
    this.ManageCifWiseComissionSvc.getModeOfPayment().subscribe((res) => {
      this.modeOfPayment = res;
    });
  }

  onSelectModeOfPayment($event) {
    this.modeOfPaymentID = $event.target.value;
  }

  getSubAgentList(ReceAgentID: any) {
    this.ManageCifWiseComissionSvc.getSubAgentList(ReceAgentID).subscribe(
      (res) => {
        this.subAgentList = res;
      }
    );
  }

  onSelectSubAgent($event) {
    this.subAgentID = $event.target.value;
  }

  getAllRecord() {
    this.ManageCifWiseComissionSvc.getAllRecord(
      this.ReceiveAgentID,
      this.countryID,
      this.receiveCountryID,
      this.agentID,
      this.modeOfPaymentID,
      this.subAgentID
    ).subscribe((res) => {
      this.allRecord = res;
    });
  }

  deleteRecord() {
    const payload = this.isDeleted();
    this.ManageCifWiseComissionSvc.deleteRecord(payload).subscribe((res) => {
      res;
    });
    this.getAllRecord();
  }

  isDeleted() {
    return this.allRecord
      .filter((con) => con.isDeleted)
      .map((con) => ({
        ID: con?.ID,
        RecSubAgent: this.subAgentID,
      }));
  }

  getSendCountryInsert() {
    this.ManageCifWiseComissionSvc.getSendCountryInsert().subscribe((res) => {
      this.sendCountryInsertList = res;
    });
  }
  onSelectSendCountryInsert($event) {
    this.PayInCountryId = $event.target.value;
    this.getSendAgentInsert(this.PayInCountryId);
    this.getSendCurrencyInsert(this.PayInCountryId);
  }

  getSendAgentInsert(PayInCountryId: any) {
    this.ManageCifWiseComissionSvc.getSendAgentInsert(PayInCountryId).subscribe(
      (res) => {
        this.sendAgentInsertList = res;
      }
    );
  }
  onSelectAddAgent($event) {
    this.Agent_ID = $event.target.value;
    this.getModeOfPaymentInsert();
  }

  getSendCurrencyInsert(countryId: any) {
    this.ManageCifWiseComissionSvc.getSendCurrencyInsert(countryId).subscribe(
      (res) => {
        this.sendCurrencyInsertList = res;
      }
    );
  }

  getModeOfPaymentInsert() {
    this.ManageCifWiseComissionSvc.getModeOfPaymentInsert().subscribe((res) => {
      this.ModeOfPaymentInsert = res;
    });
  }

  getCifNumber() {
    this.ManageCifWiseComissionSvc.getCifNumber().subscribe((res) => {
      this.cifNumber = res;
    });
  }

  getInsertReceiveCountry() {
    this.ManageCifWiseComissionSvc.getInsertReceiveCountry().subscribe(
      (res) => {
        this.insertReceiveCountryList = res;
      }
    );
  }

  getSendAgentInsertList(currencyId: any, countryId: any) {
    this.ManageCifWiseComissionSvc.getSendAgentInsertList(
      currencyId,
      countryId
    ).subscribe((res) => {
      res;
    });
  }

  getReceiveCurrencyInsert(payOutCountryId: any) {
    this.ManageCifWiseComissionSvc.getReceiveCurrencyInsert(
      payOutCountryId
    ).subscribe((res) => {
      this.insertReceiveCurrencyList = res;
    });
  }

  onSelectReceiveCurrency($event) {
    this.selectReceiveCurrencyID = $event.target.value;
    this.getReceiveAgentInsert(
      this.selectReceiveCurrencyID,
      this.receiveCountryID
    );
    this.getRangeCurrency();
    const sendCurrencyType = this.insertReceiveCurrencyList?.find(
      (currency) => currency?.Currency_Id === parseInt($event.target.value)
    );

    this.CurrencyType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency.Currency_Id,
        CurrencyType: currency.CurrencyShortName,
        // Add more key renaming as needed
      };
    });
  }

  getReceiveAgentInsert(receiveCurrencyId: any, payOutCountryId: any) {
    this.ManageCifWiseComissionSvc.getReceiveAgentInsert(
      receiveCurrencyId,
      payOutCountryId
    ).subscribe((res) => {
      this.ReceiveAgentInsertList = res;
    });
  }

  onSelectReceiveAgentID($event) {
    this.getReceiveSubAgentInsert($event.target.value);
  }

  getReceiveSubAgentInsert(agentId) {
    this.ManageCifWiseComissionSvc.getReceiveSubAgentInsert(agentId).subscribe(
      (res) => {
        this.ReceiveSubAgentInsertList = res;
        console.log('res: ', res);
      }
    );
  }
  getRangeCurrencyInsert() {
    this.ManageCifWiseComissionSvc.getRangeCurrencyInsert().subscribe((res) => {
      this.RangeCurrency = res;
      this.sendCurrencyType = res;
      if (!this.areArraysEqual(this.sendCurrencyType, this.CurType)) {
        this.sendCurrencyType = this.sendCurrencyType.concat(this.CurType);
      }
    });
  }

  getRangeCurrency() {
    this.ManageCifWiseComissionSvc.getRangeCurrencyInsert().subscribe((res) => {
      this.receiveCurrencyType = res;
      if (!this.areArraysEqual(this.receiveCurrencyType, this.CurrencyType)) {
        this.receiveCurrencyType = this.receiveCurrencyType.concat(
          this.CurrencyType
        );
      }
    });
  }

  onSelectSendCurrency($event) {
    this.getRangeCurrencyInsert();
    const sendCurrencyType = this.sendCurrencyInsertList?.find(
      (currency) => currency?.Currency_Id === parseInt($event.target.value)
    );

    this.CurType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency.Currency_Id,
        CurrencyType: currency.CurrencyShortName,
        // Add more key renaming as needed
      };
    });

    if (!this.areArraysEqual(this.sendCurrencyType, this.CurType)) {
      this.sendCurrencyType = this.sendCurrencyType.concat(this.CurType);
    }
  }

  areArraysEqual(sendCurrencyType, currency) {
    if (sendCurrencyType.length !== currency.length) {
      return false;
    }
    sendCurrencyType.sort();
    currency.sort();
    for (let i = 0; i < sendCurrencyType.length; i++) {
      for (let key in sendCurrencyType[i]) {
        if (sendCurrencyType[i][key] !== currency[i][key]) {
          return false;
        }
      }
    }
    return true;
  }

  get f() {
    return this.ManageCifWiseCommissionForm.value;
  }

  addRecord(type: any) {
    this.type = type;
    console.log('this.f.SubAgentID: ', this.f.SubAgentID);
    const payload = {
      AgentID: Number(this.f.AgentID) || 0,
      BaseToBaseCommissionAmount: Number(this.f.BaseToBaseCommissionAmount),
      CIFNumber: this.f.CIFNumber,
      EndRange: Number(this.f.EndRange),
      EnteredBy: 'None',
      ID: Number(0),
      IsSubAgent: this.f.SubAgentID ? true : false,
      IschkMinMax: true,
      ModeOfPayment_ID: Number(this.f.ModeOfPayment_ID) || 0,
      PayCommissionType: Number(this.f.PayCommissionType),
      PayInCommissionAmount: Number(this.f.PayInCommissionAmount),
      PayInCommissionType: Number(this.f.PayInCommissionType),
      PayInCountryId: Number(this.f.PayInCountryId),
      PayInCurrencyID: Number(this.f.PayInCurrencyID) || 0,
      PayInCurrencyType: Number(this.f.PayInCurrencyType) || 0,
      PayOutCommissionAmount: Number(this.f.PayOutCommissionAmount),
      PayOutCommissionType: Number(this.f.PayOutCommissionType),
      PayOutCountryId: Number(this.f.PayOutCountryId),
      PayOutCurrencyID: Number(this.f.PayOutCurrencyID) || 0,
      PayOutCurrencyType: Number(this.f.PayOutCurrencyType) || 0,
      RangeCurrencyType: Number(this.f.RangeCurrencyType) || 0,
      RecAgentID: Number(this.f.RecAgentID) || 0,
      ReceiverFixAmount: Number(this.f.ReceiverFixAmount) || 0,
      ReceiverMaxAmount: Number(this.f.ReceiverMaxAmount) || 0,
      ReceiverMinAmount: Number(this.f.ReceiverMinAmount) || 0,
      StartRange: Number(this.f.StartRange),
      SubAgentID: this.f.SubAgentID,
    };
    if (this.f.PayInCountryId == 'None') {
      alert('Please Select Send Country !');
      return;
    }
    if (this.f.CIFNumber == 'None') {
      alert('Please Select CIF Number!');
      return;
    }
    if (this.f.PayOutCountryId == 'None') {
      alert('Please Select Receive Country!');
      return;
    }

    if (this.f.StartRange == '') {
      alert('Please Enter Start Range Amount!!');
      return;
    }

    if (this.f.EndRange == '') {
      alert('Please Enter End Range Amount!');
      return;
    }
    if (this.f.EndRange < this.f.StartRange) {
      alert('End Range should be greater than Start Range!');
      return;
    }
    if (this.f.BaseToBaseCommissionAmount == '') {
      alert('Please Total Commission Amount!');
      return;
    }
    if (this.f.PayCommissionType == 'None') {
      alert('Please Select Total Commission Type!');
      return;
    }
    if (this.f.PayInCommissionType == 'None') {
      alert('Please Select Send Commission Type!');
      return;
    }
    if (this.f.PayInCommissionAmount == '') {
      alert('Please Enter Send Commission Amount!');
      return;
    }
    if (this.f.PayOutCommissionType == 'None') {
      alert('Please Select Receive Commission Type!');
      return;
    }

    if (this.f.PayOutCommissionAmount == '') {
      alert('Please Enter Receive Commission Amount!');
      return;
    }
    if (type == 'Add') {
      this.ManageCifWiseComissionSvc.addRecord(payload).subscribe((res) => {
        res;
        this.modalService.hide();
      });
    }

    if (type == 'Edit') {
      if (this.f.ReceiverFixAmount == '') {
        alert('Please Enter Fixed Amount!');
        return;
      }
      if (this.f.ReceiverMinAmount == '') {
        alert('Please Enter Min Amount!');
        return;
      }
      if (this.f.ReceiverMaxAmount == '') {
        alert('Please Enter Max Amount!');
        return;
      }
      const payload = {
        AgentID: Number(this.f.AgentID),
        BaseToBaseCommissionAmount: Number(this.f.BaseToBaseCommissionAmount),
        CIFNumber: this.f.CIFNumber,
        EndRange: Number(this.f.EndRange),
        EnteredBy: 'None',
        ID: Number(this.f.ID),
        IsSubAgent: this.f.SubAgentID ? true : false,
        IschkMinMax: true,
        ModeOfPayment_ID: Number(this.f.ModeOfPayment_ID),
        PayCommissionType: Number(this.f.PayCommissionType),
        PayInCommissionAmount: Number(this.f.PayInCommissionAmount),
        PayInCommissionType: Number(this.f.PayInCommissionType),
        PayInCountryId: Number(this.f.PayInCountryId),
        PayInCurrencyID: Number(this.f.PayInCurrencyID),
        PayInCurrencyType: Number(this.f.PayInCurrencyType),
        PayOutCommissionAmount: Number(this.f.PayOutCommissionAmount),
        PayOutCommissionType: Number(this.f.PayOutCommissionType),
        PayOutCountryId: Number(this.f.PayOutCountryId),
        PayOutCurrencyID: Number(this.f.PayOutCurrencyID),
        PayOutCurrencyType: Number(this.f.PayOutCurrencyType),
        RangeCurrencyType: Number(this.f.RangeCurrencyType),
        RecAgentID: Number(this.f.RecAgentID),
        ReceiverFixAmount: Number(this.f.ReceiverFixAmount),
        ReceiverMaxAmount: Number(this.f.ReceiverMaxAmount),
        ReceiverMinAmount: Number(this.f.ReceiverMinAmount),
        StartRange: Number(this.f.StartRange),
        SubAgentID: Number(this.f.SubAgentID),
      };
      this.ManageCifWiseComissionSvc.updateRecord(payload).subscribe((res) => {
        res;
        console.log('res: ', res);
      });
    }
  }
  getTotalCommissionType() {
    this.ManageCifWiseComissionSvc.getTotalCommissionType().subscribe((res) => {
      this.TotalCommissionType = res;
    });
  }
  edit(ID, IsSubAgent, type = 'edit') {
    this.type = type;
    this.ManageCifWiseComissionSvc.edit(ID, IsSubAgent).subscribe((res) => {
      res;
      this.ManageCifWiseCommissionForm.patchValue({
        PayInCountryId: res[0].PayInCountryId,
      });
      this.getSendCurrencyInsert(this.f.PayInCountryId);
      this.getSendAgentInsert(this.f.PayInCountryId);
      this.ManageCifWiseCommissionForm.patchValue({
        AgentID: res[0].Agent_ID,
      });
      this.getModeOfPaymentInsert();
      this.ManageCifWiseCommissionForm.patchValue({
        ModeOfPayment_ID: res[0].ModeOfPayment_ID,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        CIFNumber: res[0].CIFNumber,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayInCurrencyID: res[0].PayInCurrencyID,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayOutCountryId: res[0].PayOutCountryId,
      });
      this.getReceiveCurrencyInsert(this.f.PayOutCountryId);
      this.ManageCifWiseCommissionForm.patchValue({
        PayOutCurrencyID: res[0].PayOutCurrencyID,
      });
      this.getReceiveAgentInsert(
        this.f.PayOutCurrencyID,
        this.f.PayOutCountryId
      );
      this.ManageCifWiseCommissionForm.patchValue({
        RecAgentID: res[0].ReceivingAgent || 'None',
      });
      this.ManageCifWiseCommissionForm.patchValue({
        RangeCurrencyType: res[0].RangeCurrencyType,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        StartRange: res[0].StartRange,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        EndRange: res[0].EndRange,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        BaseToBaseCommissionAmount: res[0].BaseToBaseCommissionAmount,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayCommissionType: res[0].PayCommissionType,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayInCommissionType: res[0].PayInCommissionType,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayInCurrencyType: res[0].PayInCurrencyType,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayInCommissionAmount: res[0].PayInCommissionAmount,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayOutCommissionType: res[0].PayOutCommissionType,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayOutCurrencyType: res[0].PayOutCurrencyType,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        PayOutCommissionAmount: res[0].PayOutCommissionAmount,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        ID: res[0].ID,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        ReceiverFixAmount: res[0].PayOutFixAmount,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        ReceiverMinAmount: res[0].PayOutMinAmount,
      });
      this.ManageCifWiseCommissionForm.patchValue({
        ReceiverMaxAmount: res[0].PayOutMaxAmount,
      });
      console.log('this.f: ', this.f);
    });
    this.onEditSendCurrencyType();
    this.onEditReceiveCurrencyType(this.f.PayOutCurrencyType);
  }

  get checkType() {
    let type = this.type;
    switch (type) {
      case 'add':
        return (type = 'Add');
      case 'edit':
        return (type = 'Edit');
      default:
        return type;
    }
  }
  onEditSendCurrencyType() {
    this.getRangeCurrencyInsert();

    const sendCurrencyType = this.sendCurrencyInsertList?.find(
      (currency) => currency?.Currency_Id === parseInt(this.f.PayInCurrencyType)
    );

    this.CurType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency?.Currency_Id,
        CurrencyType: currency?.CurrencyShortName,
        // Add more key renaming as needed
      };
    });

    if (!this.areArraysEqual(this.sendCurrencyType, this.CurType)) {
      this.sendCurrencyType = this.sendCurrencyType.concat(this.CurType);
    }
  }

  onEditReceiveCurrencyType(type = 'edit') {
    this.getRangeCurrency();

    const sendCurrencyType = this.insertReceiveCurrencyList?.find(
      (currency) =>
        currency?.Currency_Id === parseInt(this.f.PayOutCurrencyType)
    );

    this.CurrencyType = Array(sendCurrencyType).map((currency) => {
      return {
        ID: currency?.Currency_Id,
        CurrencyType: currency?.CurrencyShortName,
      };
    });
    if (this.f.PayOutCurrencyType == 'None') {
    } else {
      this.openManageCifWiseComissionModel('edit');
    }
  }
  Reset() {
    this.ManageCifWiseCommissionForm.reset({
      PayInCountryId: 'None',
      AgentID: 'None',
      ModeOfPayment_ID: 'None',
      CIFNumber: 'None',
      PayInCurrencyID: 'None',
      PayOutCountryId: 'None',
      PayOutCurrencyID: 'None',
      RecAgentID: 'None',
      SubAgentID: null,
      RangeCurrencyType: 'None',
      StartRange: '',
      EndRange: '',
      BaseToBaseCommissionAmount: '',
      PayCommissionType: 'None',
      PayInCommissionType: 'None',
      PayInCurrencyType: 'None',
      PayInCommissionAmount: '',
      PayOutCommissionType: 'None',
      PayOutCurrencyType: 'None',
      PayOutCommissionAmount: '',
    });
  }
}
