import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ReceivingPercentageWiseService {
  constructor(private http: HttpClient) {}

  getReceivingCountryList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/receiving-country-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/agent-list?CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAllRecord(AgentID: any, PayOutCountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/all-record?AgentID=${AgentID}&PayOutCountryID=${PayOutCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getModeOfPayment(CountryID: any, AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/mode-of-payment?CountryID=${CountryID}&AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getReceiveCountryInsert() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receivecountry-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrencyInsert(CountryID: any, AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/sendcurrency-insert?CountryID=${CountryID}&AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReciveAgentInsert(CountryID: any, CurrencyID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receiveagent-insert?CountryID=${CountryID}&CurrencyID=${CurrencyID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTotalCommissionTypeInsert() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country-wise-commissionn/totalcommission-type-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrencyType() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country-wise-commission/sendcurrencytype-insert`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCommissionOn() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/commission-on`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  insert(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/insert`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  edit(ID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/edit?ID=${ID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateRecord(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  gridUpdate(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/ra-agent-min-max-commission/grid-update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
