import { Component, ViewChild, TemplateRef } from '@angular/core';
import { BsModalService, BsModalRef } from 'ngx-bootstrap/modal';

@Component({
  selector: 'app-rejected-beneficiary',
  templateUrl: './rejected-beneficiary.component.html',
  styleUrls: ['./rejected-beneficiary.component.css'],
})
export class RejectedBeneficiaryComponent {
  bsModalRef: BsModalRef;

  @ViewChild('updateBeneficiaryRegistration')
  manageagentuserTemplate: TemplateRef<any>;

  selectedCriteria: string = 'all';
  beneficiaryNumber: string = '';
  nickName: string = '';
  startDate: string = '';
  endDate: string = '';

  constructor(private modalService: BsModalService) {}

  search() {
    console.log('Search criteria:', this.selectedCriteria);
    console.log('Beneficiary Number:', this.beneficiaryNumber);
    console.log('Nick Name:', this.nickName);
    console.log('Start Date:', this.startDate);
    console.log('End Date:', this.endDate);
  }

  openBeneficiaryModal() {
    this.bsModalRef = this.modalService.show(this.manageagentuserTemplate, {
      class: 'modal-lg',
    });
  }
}
