import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class ManageCityService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getAllCities(token: any, username, countryId = 0): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/city?countryId=${countryId}`,
      {
        headers: headers,
      }
    );
  }

  addCity(token: any, username: any, payload: any): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/city
      `,
      payload,
      {
        headers: headers,
      }
    );
  }

  updateCity(token: any, username: any, payload: any): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/city`,
      payload,
      {
        headers: headers,
      }
    );
  }
}
