import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class ManageCurrencyService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getCurrencies(token: any, username, currencyId: any = 0): Observable<any> {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/currency?currencyId=${currencyId}`,
      {
        headers: {
          Authorization: token,
          Accept: 'application/json',
          username: username,
        },
      }
    );
  }

  addCurrency(token: any, username: any, payload): Observable<any> {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/currency`,
      payload,
      {
        headers: {
          Authorization: token,
          Accept: 'application/json',
          username: username,
        },
      }
    );
  }

  updateCurrency(token: any, username: any, payload): Observable<any> {
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/currency`,
      payload,
      {
        headers: {
          Authorization: token,
          Accept: 'application/json',
          username: username,
        },
      }
    );
  }
}
