import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class ManagePurposeOfTransferService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getAllPurposeOfTransfer(
    token: any,
    username,
    purposeofTransferId = 0
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/purpose-of-transfer?purposeoftransferId=${purposeofTransferId}`,
      {
        headers: headers,
      }
    );
  }

  addPurposeofTransfer(
    token: any,
    username: any,
    payload: any
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/purpose-of-transfer`,
      payload,
      {
        headers: headers,
      }
    );
  }

  updatePurposeofTransfer(
    token: any,
    username: any,
    payload: any
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/purpose-of-transfer`,
      payload,
      {
        headers: headers,
      }
    );
  }
}
