import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ManageSourceOfIncomeService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSourceOfIncomeList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/source-of-incomeName/dropdown`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(sourceOfIncome: any = '') {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/source-of-incomeName/grid?SourceOfIncome=${sourceOfIncome}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addSourceOfIncome(sourceOfIncome: any = '', isActive: any = false) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/source-of-incomeName/add?SourceOfIncomeName=${sourceOfIncome}&chkIsActive=${isActive}&G_UserID=1`,
      '',
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateSourceOfIncome(
    sourceOfIncomeId: any = 0,
    sourceOfIncomeName: any = '',
    isActive: any = false
  ) {
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/source-of-incomeName/update?SourceOfIncome_ID=${sourceOfIncomeId}&SourceOfIncome_Name=${sourceOfIncomeName}&Active=${isActive}&G_UserID=1`,
      '',
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
