import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SearchTransactionsService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getLcCurrencyList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/transaction-search/lc-currency?UserID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentList(currencyId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/transaction-search/send-agent?CurrencyId=${currencyId}&UserID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFcCurrencyList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/transaction-search/fc-currency`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceivingAgentList(currencyId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/transaction-search/receiving-agent?CurrencyId=${currencyId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  searchTransactionDetail(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/transaction-management/transaction-search/transaction-search-detail`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
