import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class TagMappingService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getMappingMethodList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/tag-mapping/mapping-method-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/tag-mapping/agent-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
