import { Component } from '@angular/core';
import { TagMappingService } from '../services/tag-mapping.service';

@Component({
  selector: 'app-tag-mapping',
  templateUrl: './tag-mapping.component.html',
  styleUrls: ['./tag-mapping.component.css'],
})
export class TagMappingComponent {
  mappingMethodList: any = [];
  selectedMappingMethod: any = '0';
  agentList: any = [];
  selectedAgent: any = '0';

  constructor(private tagMappingSvc: TagMappingService) {}

  ngOnInit(): void {
    this.getMappingMethodList();
    this.getAgentList();
  }

  getMappingMethodList() {
    this.tagMappingSvc.getMappingMethodList().subscribe({
      next: (res: any) => {
        this.mappingMethodList = res;
      },
      error: (err) => {
        this.mappingMethodList = [];
      },
      complete: () => {},
    });
  }

  getAgentList() {
    this.tagMappingSvc.getAgentList().subscribe({
      next: (res: any) => {
        this.agentList = res;
      },
      error: (err) => {
        this.agentList = [];
      },
      complete: () => {},
    });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
