import { Component, OnInit } from '@angular/core';
import { ViewComplianceTransactionReportService } from '../services/view-compliance-transaction-report.service';

@Component({
  selector: 'app-view-compliance-transaction-report',
  templateUrl: './view-compliance-transaction-report.component.html',
  styleUrls: ['./view-compliance-transaction-report.component.css'],
})
export class ViewComplianceTransactionReportComponent implements OnInit {
  fromDate: string = '';
  toDate: string = '';
  status: string = '';
  statusOptions: string[] = ['Pending', 'Approved', 'Rejected'];
  complianceDetails: any[] = [];

  constructor(
    private viewComplianceService: ViewComplianceTransactionReportService
  ) {}

  ngOnInit() {}
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  fetchData() {
    this.viewComplianceService
      .getComplianceDetailsReport(this.fromDate, this.toDate, this.status)
      .subscribe(
        (data: any) => {
          this.complianceDetails = data.complianceDetails;
        },
        (error) => {
          console.error(error);
        }
      );
  }

  onSubmit() {
    this.fetchData();
  }
}
