import { Component } from '@angular/core';
import { ViewPendingApprovalService } from '../view-pending-approval.service';

@Component({
  selector: 'app-view-pending-approval',
  templateUrl: './view-pending-approval.component.html',
  styleUrls: ['./view-pending-approval.component.css'],
})
export class ViewPendingApprovalComponent {
  UserList: any;
  AgentList: any;
  DestCurrencyList: any;
  status: any;
  searchByType: any = 1;
  AgentTypeList: any;
  AgentID: any;
  SendCountryList: any;
  PayoutCountryList: any;
  SendCurrencyList: any;
  AgentBranchList: any;
  constructor(private ViewPendingApprovalSvc: ViewPendingApprovalService) {}

  ngOnInit(): void {
    this.getStatus();
    this.getAgentTypeList();
    this.getSendCountryList();
    this.getPayoutCountryList();
  }

  onSelectSearchFilter(No) {
    this.searchByType = No;
  }

  getStatus() {
    this.ViewPendingApprovalSvc.getStatus().subscribe((res) => {
      this.status = res;
    });
  }

  getAgentTypeList() {
    this.ViewPendingApprovalSvc.getAgentTypeList().subscribe((res) => {
      this.AgentTypeList = res;
    });
  }

  getSendCountryList() {
    this.ViewPendingApprovalSvc.getSendCountryList().subscribe((res) => {
      this.SendCountryList = res;
    });
  }
  onSelectCountry(CountryID) {
    this.getAgentList(CountryID);
    this.getSendCurrencyList(CountryID);
  }

  getSendCurrencyList(CountryID) {
    this.ViewPendingApprovalSvc.getSendCurrencyList(CountryID).subscribe(
      (res) => {
        this.SendCurrencyList = res;
      }
    );
  }

  getPayoutCountryList() {
    this.ViewPendingApprovalSvc.getPayoutCountryList().subscribe((res) => {
      this.PayoutCountryList = res;
    });
  }

  onSelectPayoutCountry(CountryID) {
    this.getDestCurrencyList(CountryID);
  }

  getDestCurrencyList(CountryID) {
    this.ViewPendingApprovalSvc.getDestCurrencyList(CountryID).subscribe(
      (res) => {
        this.DestCurrencyList = res;
      }
    );
  }

  getAgentList(CountryID) {
    this.ViewPendingApprovalSvc.getAgentList(CountryID).subscribe((res) => {
      this.AgentList = res;
    });
  }

  onSelectAgent(AgentID) {
    this.AgentID = AgentID;
    this.getAgentBranchList(AgentID);
  }

  getAgentBranchList(AgentID) {
    this.ViewPendingApprovalSvc.getAgentBranchList(AgentID).subscribe((res) => {
      this.AgentBranchList = res;
    });
  }

  onSelectAgentBranch(AgentBranchID) {
    this.getUserList(AgentBranchID);
  }
  getUserList(AgentBranchID: any) {
    this.ViewPendingApprovalSvc.getUserList(
      this.AgentID,
      AgentBranchID
    ).subscribe((res) => {
      this.UserList = res;
    });
  }
}
